package RT::Extension::PreviousOwner;

use warnings;
use strict;

=head1 NAME

RT::Extension::PreviousOwner - The great new RT::Extension::PreviousOwner!

=head1 VERSION

Version 0.01

=cut

our $VERSION = '0.01';


=head1 SYNOPSIS

Quick summary of what the module does.

Perhaps a little code snippet.

    use RT::Extension::PreviousOwner;

    my $foo = RT::Extension::PreviousOwner->new();
    ...

=head1 EXPORT

A list of functions that can be exported.  You can delete this section
if you don't export anything, such as for a purely object-oriented module.

=head1 SUBROUTINES/METHODS

=head2 function1

=cut

sub function1 {
}

=head2 function2

=cut

sub function2 {
}

=head1 AUTHOR

Matt Zagrabelny, C<< <mzagrabe at d.umn.edu> >>

=head1 BUGS

Please report any bugs or feature requests to C<bug-rt-extension-previousowner at rt.cpan.org>, or through
the web interface at L<http://rt.cpan.org/NoAuth/ReportBug.html?Queue=RT-Extension-PreviousOwner>.  I will be notified, and then you'll
automatically be notified of progress on your bug as I make changes.




=head1 SUPPORT

You can find documentation for this module with the perldoc command.

    perldoc RT::Extension::PreviousOwner


You can also look for information at:

=over 4

=item * RT: CPAN's request tracker

L<http://rt.cpan.org/NoAuth/Bugs.html?Dist=RT-Extension-PreviousOwner>

=item * AnnoCPAN: Annotated CPAN documentation

L<http://annocpan.org/dist/RT-Extension-PreviousOwner>

=item * CPAN Ratings

L<http://cpanratings.perl.org/d/RT-Extension-PreviousOwner>

=item * Search CPAN

L<http://search.cpan.org/dist/RT-Extension-PreviousOwner/>

=back


=head1 ACKNOWLEDGEMENTS


=head1 LICENSE AND COPYRIGHT

Copyright 2011 Matt Zagrabelny.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 dated June, 1991 or at your option
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

A copy of the GNU General Public License is available in the source tree;
if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


=cut

package RT::Ticket;

sub PreviousOwner {
    my $self = shift;
    my %args = (
        omit_nobody_from_results => 1,
        default_return_nobody    => 0,
	    @_,
    );

    my $txns = $self->Transactions;
    $txns->Limit(
        FIELD    => 'Field',
        OPERATOR => '=',
        VALUE    => 'Owner',
    );
    $txns->OrderByCols(
        { FIELD => "Created", ORDER => 'DESC' },
        { FIELD => "id",      ORDER => 'DESC' },
    );

    my $previous_owner = undef;

    TRANSACTION:
    while (my $txn = $txns->Next) {
        my $possible_previous_owner_id = $txn->OldValue;

        if (
            $args{omit_nobody_from_results}
            &&
            $possible_previous_owner_id == $RT::Nobody->Id
        ) {
            next TRANSACTION;
        }

        my $owner = new RT::User($self->CurrentUser);
        $owner->Load($possible_previous_owner_id);

        return $owner->RealName;
    }

    return ($args{default_return_nobody} ?  $RT::Nobody->RealName : "--");
}

1; # End of RT::Extension::PreviousOwner
